-Top- -Classes- -Public Operations- -Class Diagrams- -Sequence Diagrams-

_ A B C D E F G H I J K L M N O P R S T U V W ~

Class UmlBaseItem

Declaration :

- C++ : class UmlBaseItem
- Java : abstract class UmlBaseItem

Directly inherited by : UmlItem

Base class of all the classes representing browser's objects.
In the API all for each 'system' class exists a 'user' class under your responsability which inherits the 'system' class.
You do not have to change the 'system' classes, place your attributes and operations in the corresponding 'user' classes : all the instances made by the 'system' classes are instance of the corresponding 'user' classes.
You must never create or delete yourself a class of the API, use the Create operation defined in the 'system' classes.
To not allow you to access to the 'system' attributes or to call 'system' internal operations even by error, the 'system' internal parts are declared 'private' rather than 'public' or 'protected'.

Artifact : UmlBaseItem

Operation kind

Declaration :

- C++ : public: virtual anItemKind kind()= 0
- Java : public abstract anItemKind kind()

returns the kind of the item

Operation name

Declaration :

- C++ : public: const QCString & name()
- Java : public String name()

returns the name

Operation set_Name

Declaration :

- C++ : public: bool set_Name(const QCString & s)
- Java : public void set_Name(String s) throws RuntimeException

to set the name On error return FALSE in C++, produce a RuntimeException in Java

Operation stereotype

Declaration :

- C++ : public: const QCString & stereotype()
- Java : public String stereotype()

returns the stereotype

Operation set_Stereotype

Declaration :

- C++ : public: virtual bool set_Stereotype(const QCString & s)
- Java : public void set_Stereotype(String s) throws RuntimeException

to set the stereotype On error return FALSE in C++, produce a RuntimeException in Java

Operation description

Declaration :

- C++ : public: const QCString & description()
- Java : public String description()

returns the description

Operation set_Description

Declaration :

- C++ : public: bool set_Description(const QCString & s)
- Java : public void set_Description(String s) throws RuntimeException

to set the description On error return FALSE in C++, produce a RuntimeException in Java

Operation parent

Declaration :

- C++ : public: UmlItem * parent()
- Java : public UmlItem parent()

returns the parent (0/null if it is applied on the project itself), to go all over the browser tree

Operation children

Declaration :

- C++ : public: const QVector<UmlItem> children()
- Java : public UmlItem[] children()

returns (in Java : a copy of) the children list, to go all over the browser tree

Operation childrenVisible

Declaration :

- C++ : public: bool childrenVisible()
- Java : public boolean childrenVisible()

return TRUE if the children exist and are visible (independently of the scroll bar) in the browser, else FALSE

Operation set_childrenVisible

Declaration :

- C++ : public: bool set_childrenVisible(bool y)
- Java : public void set_childrenVisible(boolean y) throws RuntimeException

open the item in the browser (its children are visible) if y is TRUE, else close it (its children are not visible). May be applied on items without children. The item is also selected in the browser, so set_ChildrenVisible(childrenVisible()) is the right way to select the item in the browser.
On error return FALSE in C++, produce a RuntimeException in Java

Operation propertyValue

Declaration :

- C++ : public: bool propertyValue(const QCString & k, QCString & v)
- Java : public String propertyValue(String k)

In C++, in case the key specified by 'k' exist for the current object, the string 'v' is modified which the associated value and TRUE is returned, else returns FALSE.
In Java return the value associated with the key specified by 'k' for the current object, null in case the property doesn't exist.
These properties may be edited through the object dialog last tab named 'user'

Operation set_PropertyValue

Declaration :

- C++ : public: bool set_PropertyValue(const QCString & k, const QCString & v)
- Java : public void set_PropertyValue(String k, String v) throws RuntimeException

to set (may be insert a new) the value 'v' associated to the key 'k' On error return FALSE in C++, produce a RuntimeException in Java

Operation properties

Declaration :

- C++ : public: const QDict<QCString> properties()
- Java : public Hashtable properties()

returns all the properties of the object through (in Java a copy of) a dictionnary

Operation supportFile

Declaration :

- C++ : public: QCString supportFile()
- Java : public String supportFile()

Returns the absolute path name of the file memoring the Item. In general an item is saved in a file associated to its package, the exceptions are :
- the body of the operations of a class which definition contains the keyword '{$body}'. This path name is returned when you apply supportFile on any operation of the class.
- the drawing of the diagrams, this path name is returned when you apply supportFile on the diagram.
- the configuration of the tools edited throw the entry 'Tools Settings' of the menu Tools is saved in the file 'tools'
- the configuration of the '#include' and 'using' forms associated to the external type and edited through the last C++ tab of the 'Generation Settings' dialog is saved in the file 'cpp_includes'
- the configuration of the 'imports' forms associated to the external types and edited through the last Java tab of the 'Generation Settings' dialog is saved in the file 'java_imports'
- the configuration of the '#include' forms associated to the external type and edited through the last Idl tab of the 'Generation Settings' dialog is saved in the file 'idl_includes'

Operation isWritable

Declaration :

- C++ : public: bool isWritable()
- Java : public boolean isWritable()

return TRUE in case the item may be modified, i.e. it is not an API base 'plug-out' class and the corresponding file(s) are not read-only.

Operation apply

Declaration :

- C++ : public: int apply(QCString cmd)
- Java : public int apply(String cmd)

Apply asynchronously the tool on the item, returns an identifier to call isToolDone()

Operation isMarked

Declaration :

- C++ : public: bool isMarked()
- Java : public boolean isMarked()

return TRUE in case the item is marked

Operation set_isMarked

Declaration :

- C++ : public: bool set_isMarked(bool y)
- Java : public void set_isMarked(boolean y) throws RuntimeException

to mark/unmark the current item. The project cannot marked On error return FALSE in C++, produce a RuntimeException in Java

Operation referencedBy

Declaration :

- C++ : public: const QVector<UmlItem> referencedBy()
- Java : public UmlItem[] referencedBy()

Returns the items referencing the current one. The result may contains UmlRelations (their target is the current item), UmlNcRelations (their target is the current item) or UmlComponents (the associated component of the current item when it is a UmlClass, a non source component associated with the current one).

Operation unload

Declaration :

- C++ : public: virtual void unload(bool rec = FALSE, bool del = FALSE)
- Java : public void unload(boolean rec, boolean del)

to unload the object to free memory, it will be reloaded automatically if needed. Recursively done for the sub items if 'rec' is TRUE.
if 'del' is true the sub items are deleted in C++, and removed from the internal dictionnary in C++ and Java (to allow it to be garbaged), you will have to call Children() to re-access to them

Operation isToolRunning

Declaration :

- C++ : public: static bool isToolRunning(int id)
- Java : public static boolean isToolRunning(int id)

'id' is an identifier returned by apply(), indicates if the tool is still running

Operation markedItems

Declaration :

- C++ : public: static const QVector<UmlItem> markedItems()
- Java : public static UmlItem[] markedItems()

Extra Class Member remark

Definition :

- Java :

       /**  * Do NOT use the next definitions  */

Attribut _defined

Declaration :

- C++ : private: bool _defined
- Java : private boolean _defined

Attribut _marked

Declaration :

- C++ : private: bool _marked
- Java : private boolean _marked

Attribut _identifier

Declaration :

- C++ : private: void * _identifier
- Java : private long _identifier

Attribut _name

Declaration :

- C++ : private: QCString _name
- Java : private String _name

Attribut _stereotype

Declaration :

- C++ : private: QCString _stereotype
- Java : protected String _stereotype

Note : protected in Java for internal reason, but do NOT access to this field yourself !

Attribut _description

Declaration :

- C++ : private: QCString _description
- Java : private String _description

Relation _parent (<unidirectional association>)

Declaration :

- C++ : private: UmlItem * _parent
- Java : private UmlItem _parent

Attribut _children

Declaration :

- C++ : private: QVector<UmlItem> * _children
- Java : private UmlItem[] _children

Attribut _dict

Declaration :

- C++ : private: QDict<QCString> _dict
- Java : private Hashtable _dict

Attribut _all

Declaration :

- C++ : private: static QPtrDict<UmlItem> _all
- Java : private static Hashtable _all

Extra Class Member initialization

Definition :

- Java :

      static { _all = new Hashtable(997); }

Operation read_if_needed_

Declaration :

- C++ : protected: void read_if_needed_()
- Java : protected final void read_if_needed_()

internal, do NOT use it

Operation create_

Declaration :

- C++ : protected: UmlItem * create_(anItemKind k, const char * s)
- Java : protected final UmlItem create_(anItemKind k, String s) throws RuntimeException

internal, do NOT use it

Operation read_uml_

Declaration :

- C++ : protected: virtual void read_uml_()
- Java : protected void read_uml_()

internal, do NOT use it

Operation read_cpp_

Declaration :

- C++ : protected: virtual void read_cpp_()
- Java : protected void read_cpp_()

internal, do NOT use it

Operation read_java_

Declaration :

- C++ : protected: virtual void read_java_()
- Java : protected void read_java_()

internal, do NOT use it

Operation read_idl_

Declaration :

- C++ : protected: virtual void read_idl_()
- Java : protected void read_idl_()

internal, do NOT use it

Operation read_children_

Declaration :

- C++ : protected: void read_children_()
- Java : protected final void read_children_()

internal, do NOT use it

Operation reread_children_if_needed_

Declaration :

- C++ : protected: void reread_children_if_needed_()
- Java : protected final void reread_children_if_needed_()

internal, do NOT use it

Operation set_it_

Declaration :

- C++ : protected: bool set_it_(bool & r, bool v, OnInstanceCmd cmd)

internal, do NOT use it

Operation set_it_

Declaration :

- C++ : protected: bool set_it_(aVisibility & r, aVisibility v, OnInstanceCmd cmd)

internal, do NOT use it

Operation set_it_

Declaration :

- C++ : protected: bool set_it_(aDirection & r, aDirection v, OnInstanceCmd cmd)

internal, do NOT use it

Operation set_it_

Declaration :

- C++ : protected: bool set_it_(QCString & r, const char * v, OnInstanceCmd cmd)

internal, do NOT use it

Operation set_it_

Declaration :

- C++ : protected: bool set_it_(UmlTypeSpec & r, const UmlTypeSpec & t, OnInstanceCmd cmd)

internal, do NOT use it

Operation read_

Declaration :

- C++ : protected: static UmlItem * read_()
- Java : protected static UmlItem read_()

internal, do NOT use it

Operation UmlBaseItem

Declaration :

- C++ : public: UmlBaseItem(void * id, const QCString & n)
- Java : public UmlBaseItem(long id, String n)

the constructor, do not call it yourself !

Operation ~UmlBaseItem

Declaration :

- C++ : public: virtual ~UmlBaseItem()

the destructor, do not delete objects yourself !!!!!!!!!!

Operation identifier_

Declaration :

- Java : public final long identifier_()

internal, do NOT use it

Operation defined_

Declaration :

- Java : public boolean defined_()

internal, do NOT use it

All public operations :

apply , children , childrenVisible , defined_ , description , identifier_ , isMarked , isToolRunning , isWritable , kind , markedItems , name , parent , properties , propertyValue , referencedBy , set_childrenVisible , set_Description , set_isMarked , set_Name , set_PropertyValue , set_Stereotype , stereotype , supportFile , unload